
/***** option processing macros -- Geoff Bailey *****/
/*
 *  see main.c for example of use 
 */

#ifndef _OPTIONS_H_
#define _OPTIONS_H_

char *program_name = (char *)0;

#define ARGVAL (argv[1])
#define ARG(n) (argv[n])

#define startopts() if (program_name == (char *)0) program_name=argv[0]; \
                    while (argc>1 && *argv[1] == '-') { switch (*(++argv[1])) {

#define endopts() default: usage(); }}

#define noarg(val,code) case val : {code;} if (argv[1][1]) *argv[1]='-'; \
                                   else argc--,argv++;break;

#define onearg(val,code) case val : if (!*(++argv[1])) argc--,argv++; \
                                    if (argc < 2) usage(); \
                                    {code;} argc--,argv++; break;

#define nargs(val,n,code) case val : if (!*(++argv[1])) argc--,argv++; \
                                     if (argc < (n+1)) usage(); \
                                     {code;} argc-=(n),argv+=(n); break;

#endif _OPTIONS_H_

